<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.2/css/all.css" integrity="sha384-oS3vJWv+0UjzBfQzYUhtDYW+Pj2yciDJxpsK1OYPAYjqT085Qq/1cq5FLXAZQ7Ay" crossorigin="anonymous">
        <link rel="stylesheet" href="index.css">
        <title>Figures Crazy Game</title>
        <style>
        </style>
      </head>
      <body>
          <h1>EL JUEGO LOCO</h1>
          <div>
            <button id="joinButton" onclick="joinFunction()">Join</button>
        </div>
        <div id="singleUserDiv">
            <p>Tu usuario es:</p>
            <p id="singleUser"></p>
        </div>
        <div>
              <ul id="usersUl"></ul>
              <button id="startButton" onclick="startFunction()">Start</button>
          </div>
          <div id="playBoard">
                <p>Pulsa la siguiente secuencia</p>
                <ul id="correctCombination"></ul>
                <p>Opciones a elegir</p>
                <ul id="boardUl"></ul>
          </div>
          <div id="winner">
          </div>

            <script src="/socket.io/socket.io.js"></script>
            <script>
                let ul = document.getElementById("usersUl");

                const listaUsuarios = data =>{
                    ul.innerHTML = '';
                    data.forEach(function(element) {
                        var div = document.createElement("div");
                        div.classList.add("user");
                        var node = document.createElement("li");
                        var node2 = document.createElement("li");
                        node2.classList.add("puntos");
                        node.textContent = element.usuario;
                        node2.textContent = element.puntuacion;
                        div.appendChild(node);
                        div.appendChild(node2);
                        ul.appendChild(div);
                        //document.getElementById("usersLi").appendChild(node);
                    });
                }
                
                //declaro aqui correctCombination para poder comparar después que se han elegido el numero de opciones igual al de la respuesta correcta
                let correctCombination = {}
                let ulCorrectCombination = document.getElementById("correctCombination");
                const challenge = challengeData =>{
                    ulCorrectCombination.innerHTML = '';
                    correctCombination =  challengeData.correctCombination
                    correctCombination.forEach(function(element){
                        var node = document.createElement("li");
                        node.textContent = element;
                        ulCorrectCombination.appendChild(paint(element));
                    })

                    let ulBoard = document.getElementById("boardUl");
                    ulBoard.innerHTML = '';
                    challengeData.board.forEach(function(element){
                        var node = paint(element);
                        node.addEventListener("click", chooseAnswer, false);
                        ulBoard.appendChild(node);
                    })
                }

                let winnerDiv = document.getElementById("winner");
                const winner = winner => {
                    document.getElementById("playBoard").style.display = "none";
                    var node = document.createElement("p");
                    var node2 = document.createElement("p");
                    var button = document.createElement("button");
                    button.addEventListener("click", startAgain, false);
                    node.textContent = winner.usuario;
                    node2.textContent = winner.puntuacion;
                    button.textContent = "Volver a empezar";
                    winnerDiv.appendChild(node);
                    winnerDiv.appendChild(node2);
                    winnerDiv.appendChild(button);
                }

                const singleUser = singleUser => {
                    let singleUserP = document.getElementById("singleUser");
                    singleUserP.textContent = singleUser;
                }

                let socket = null;

                function joinFunction() {
                    socket = io();
                    document.getElementById("joinButton").style.display = "none";
                    document.getElementById("startButton").style.display = "block";
                    document.getElementById("singleUserDiv").style.display = "block";
                    socket.on('users',listaUsuarios);
                    socket.on("challenge", challenge);
                    socket.on("winner", winner);
                    socket.on("singleUser", singleUser);
                }
                
                function startFunction() {
                    document.getElementById("startButton").style.display = "none";
                    document.getElementById("playBoard").style.display = "block";
                    socket.emit('start', {} );
                }

                function paint(object) {
                    color = object.split(' ')[0]
                    shape = object.split(' ')[1]
                    if (shape === "Cuadrado") {
                        var node = document.createElement("i");
                        node.classList.add("far");
                        node.classList.add("fa-square");
                        } else if (shape === "Circulo"){
                        var node = document.createElement("i");
                        node.classList.add("far");
                        node.classList.add("fa-circle");
                        } else {
                        var node = document.createElement("i");
                        node.classList.add("fas");
                        node.classList.add("fa-exclamation-triangle");
                    }
                    if (color === "red") {
                        node.classList.add("red");
                        } else if (color === "green"){
                        node.classList.add("green");
                        } else {
                        node.classList.add("blue");
                    }
                    var span = document.createElement("span");
                    span.textContent = object;
                    node.appendChild(span);


                    return node;                
                }
                
                let answer = []
                function chooseAnswer() {
                    this.classList.add("selected");

                    answer.push(this.innerText)
                    console.log(answer);
                    if (answer.length === correctCombination.length) {
                        socket.emit('proposeSolution', answer );
                        answer = [];
                    }
                }

                function startAgain () {
                    document.getElementById("playBoard").style.display = "block";
                    winnerDiv.innerHTML = '';
                    socket.emit('restart', {} );
                }
                

            </script>
      </body>
</html>
